%define mainver %(echo %{version} | sed -e 's/\\([0-9]*\\.[0-9]*\\)\\.[0-9]*/\\1/')

%define module  Twisted

Name:           python-twisted
Version:        21.7.0
Release:        %mkrel 2
Summary:        Event-based framework for internet applications
License:        MIT
Group:          Development/Python
URL:            http://www.twistedmatrix.com/
Source0:        https://files.pythonhosted.org/packages/source/T/%{module}/%{module}-%{version}.tar.xz
Patch1:         Twisted--Import-gobject-from-gi.repository-in-Python-3.patch

Obsoletes:      python-twisted < 17.5.0
Provides:       python-twisted = %{version}-%{release}
Obsoletes:      python-twisted-conch 
Provides:       python-twisted-conch = %{version}-%{release}
Obsoletes:      python-twisted-core 
Provides:       python-twisted-core = %{version}-%{release}
Obsoletes:      python-twisted-lore 
Provides:       python-twisted-lore = %{version}-%{release}
Obsoletes:      python-twisted-mail 
Provides:       python-twisted-mail = %{version}-%{release}
Obsoletes:      python-twisted-names 
Provides:       python-twisted-names = %{version}-%{release}
Obsoletes:      python-twisted-news 
Provides:       python-twisted-news = %{version}-%{release}
Obsoletes:      python-twisted-pair 
Provides:       python-twisted-pair = %{version}-%{release}
Obsoletes:      python-twisted-runner 
Provides:       python-twisted-runner = %{version}-%{release}
Provides:       python-twisted-tls = %{version}-%{release}
Obsoletes:      python-twisted-web 
Provides:       python-twisted-web = %{version}-%{release}
Obsoletes:      python-twisted-words 
Provides:       python-twisted-words = %{version}-%{release}

%description
Twisted is a framework, written in Python, for writing networked
applications. It includes implementations of a number of commonly used
network services such as a web server, an IRC chat server, a mail
server, a relational database interface and an object broker. Developers
can build applications using all of these services as well as custom
services that they write themselves. Twisted also includes a user
authentication system that controls access to services and provides
services with user context information to implement their own security
models.

%package -n python3-twisted
Summary:        Python3 event-based framework for internet applications
Group:          Development/Python
BuildRequires:  python3-setuptools
BuildRequires:  python3-devel
BuildRequires:  python3-incremental
BuildRequires:  python3-zope-interface
BuildRequires:  pyproject-rpm-macros
Requires:       python3-pycrypto
Requires:       python3-pyopenssl
Requires:       python3-zope-interface
Requires:       python3-gobject3
Requires:       python3-serial
Requires:       python3-pyasn1
Requires:       python3-service-identity
Requires:       python3-typing-extensions

%description -n python3-twisted
Twisted is a framework, written in Python3, for writing networked
applications. It includes implementations of a number of commonly used
network services such as a web server, an IRC chat server, a mail
server, a relational database interface and an object broker. Developers
can build applications using all of these services as well as custom
services that they write themselves. Twisted also includes a user
authentication system that controls access to services and provides
services with user context information to implement their own security
models.

%prep
%setup -qn %{module}-%{version}
%apply_patches

%build
%pyproject_wheel

%install
# no-manual-page-for-binary
mkdir -p %{buildroot}%{_mandir}/man1/
for s in conch core mail; do
cp -a docs/$s/man/*.1 %{buildroot}%{_mandir}/man1/
done

%pyproject_install

# Packages that install arch-independent twisted plugins install here.
# https://bugzilla.redhat.com/show_bug.cgi?id=1252140
mkdir -p %{buildroot}%{python3_sitelib}/twisted/plugins

# Move and symlink python3 scripts
# no-manual-page-for-binary: man page is trial and twistd
mv %{buildroot}%{_bindir}/trial %{buildroot}%{_bindir}/trial-%{python3_version}
ln -s ./trial-%{python3_version} %{buildroot}%{_bindir}/trial-3
ln -s ./trial-%{python3_version} %{buildroot}%{_bindir}/trial

mv %{buildroot}%{_bindir}/twistd %{buildroot}%{_bindir}/twistd-%{python3_version}
ln -s ./twistd-%{python3_version} %{buildroot}%{_bindir}/twistd-3
ln -s ./twistd-%{python3_version} %{buildroot}%{_bindir}/twistd

# ambiguous shebangs
pathfix.py -pn -i %{__python3} %{buildroot}%{python3_sitelib}

%pyproject_save_files twisted


%files -n python3-twisted -f %{pyproject_files}
%doc NEWS.rst README.rst LICENSE
%{_bindir}/trial-3*
%{_bindir}/twistd-3*
%{_bindir}/cftp
%{_bindir}/ckeygen
%{_bindir}/conch
%{_bindir}/mailmail
%{_bindir}/pyhtmlizer
%{_bindir}/tkconch
%{_bindir}/trial
%{_bindir}/twist
%{_bindir}/twistd
%{_mandir}/man1/cftp.1*
%{_mandir}/man1/ckeygen.1*
%{_mandir}/man1/conch.1*
%{_mandir}/man1/mailmail.1*
%{_mandir}/man1/pyhtmlizer.1*
%{_mandir}/man1/tkconch.1*
%{_mandir}/man1/trial.1*
%{_mandir}/man1/twistd.1*


%changelog
* Thu Aug 25 2022 TerryN <terryn94 at gmail.com> 21.7.0-2pclos2022
- add requires typing-extensions

* Sun Aug 14 2022 TerryN <terryn94 at gmail.com> 21.7.0-1pclos2022
- update and rebuild for python 3.10

* Fri Jul 05 2019 tex 19.2.0-2pclos2019
- new
